diff -u -r -N rdnzl-0.10.9\container.lisp rdnzl\container.lisp
--- rdnzl-0.10.9\container.lisp	Tue Jan 02 00:53:04 2007
+++ rdnzl\container.lisp	Mon Apr 30 17:34:47 2007
@@ -34,6 +34,7 @@
 
 (defstruct (container
             (:conc-name nil)
+            (:copier copy-container-internal)
             ;; Corman Lisp doesn't know :PRINT-OBJECT
             (:print-function print-container))
   "Simple structure to wrap a pointer to a DotNetContainer object."
@@ -453,6 +454,11 @@
                           (resolve-type-name type))
                          (t
                           (property type "AssemblyQualifiedName")))))
+
+(defun copy-container (container)
+  "Create a copy of the given DotNetContainer"
+  (wrap-with-container
+   (%copy-dot-net-container (rdnzl::pointer container))))
 
 (defun make-null-object* (type-name)
   "Creates a NULL DotNetContainer with the type named by the string
diff -u -r -N rdnzl-0.10.9\doc\index.html rdnzl\doc\index.html
--- rdnzl-0.10.9\doc\index.html	Fri Apr 27 09:42:16 2007
+++ rdnzl\doc\index.html	Mon Apr 30 17:08:11 2007
@@ -64,6 +64,7 @@
       <li><a href="#unbox"><code>unbox</code></a>
       <li><a href="#new"><code>new</code></a>
       <li><a href="#cast"><code>cast</code></a>
+      <li><a href="#copy-container"><code>copy-container</code></a>
       <li><a href="#make-null-object"><code>make-null-object</code></a>
       <li><a href="#*coerce-double-floats-to-single*"><code>*coerce-double-floats-to-single*</code></a>
     </ol>
@@ -646,6 +647,15 @@
 </blockquote>
 
 <p><br>[Function]
+<br><a class=none name="copy-container"><b>copy-container</b> <i> container </i> =&gt; <i> container</i></a>
+
+<blockquote><br>
+Creates a copy of the .NET object passed. Useful for creating a reference to the object with the original type preserved when using <a href="#cast"><code>CAST</code></a>.
+Returns <code><i>container</i></code>.
+</blockquote>
+
+
+<p><br>[Function]
 <br><a class=none name="make-null-object"><b>make-null-object</b> <i> type-name </i> =&gt; <i> container</i></a>
 
 <blockquote><br>
diff -u -r -N rdnzl-0.10.9\ffi.lisp rdnzl\ffi.lisp
--- rdnzl-0.10.9\ffi.lisp	Tue Jan 02 00:53:04 2007
+++ rdnzl\ffi.lisp	Mon Apr 30 15:44:02 2007
@@ -291,6 +291,10 @@
 
 (ffi-define-function "makeDotNetContainerFromDouble"
     ((n ffi-double))
+  ffi-void-pointer)
+
+(ffi-define-function "copyDotNetContainer"
+    ((ptr ffi-void-pointer))
   ffi-void-pointer)
 
 (ffi-define-function "getArrayElement"
diff -u -r -N rdnzl-0.10.9\packages.lisp rdnzl\packages.lisp
--- rdnzl-0.10.9\packages.lisp	Tue Jan 02 00:53:04 2007
+++ rdnzl\packages.lisp	Mon Apr 30 17:38:38 2007
@@ -40,6 +40,7 @@
            :box
            :cast
            :container-p
+           :copy-container
            :define-rdnzl-call
            :disable-rdnzl-syntax
            :do-rdnzl-array
